
%%% Program sortowania bąbelkowego niedetrministycznego  z pętlą repeat-fail i append do rozboru listy
%%% Strategia: dopóki da sie coś poprawić to porawiaj; następnie zakończ.

loop:- repeat,
       write('loop'),nl,
       fail.

asort(L):- 
   retractall(list(_)),
   assert(list(L)),
   go.

go:-    
   repeat,
   list(L),
   write(L),nl,
   noimprove(L),
   !,
   nl,write('*****'),write(L),nl.

noimprove(L):- sorted(L).
noimprove(L):-
   append(P,[X,Y|K],L),
   X > Y,
   retract(list(L)),
   append(P,[Y,X|K],N), write('***'), write(N),nl,
   assert(list(N)),
   fail.

sorted([_]).
sorted([X,Y|T]):- X=<Y,sorted([Y|T]).

sort-improve-fail(L):-
   retractall(list(_)),
   assert(list(L)),
   run.
run:-
   improve,
   fail.
run:-
   list(L),
   write(L),nl.

improve:-
   list(L),
   append(F,[X,Y|R],L),
   X>Y,
   retract(list(L)),
   append(F,[Y,X|R],NL),
   assert(list(NL)).
improve:-
   list(L), 
   \+sorted(L),
   improve.
