%%% Rekurencja: lista N,,1

listaN1(0,[]) :- !.
listaN1(N,[N|W1]) :-
    N1 is N-1,
    listaN1(N1,W1).

%%% Rekurencja: lista 1..N ale z append; nieefektywne
lista1N(0,[]) :- !.
lista1N(N,L) :-
    N1 is N-1,
    lista1N(N1,L1),
    append(L1,[N],L).



% Iter 
list1N(N,W):- gen_iter(N,N,[N],W).
gen_iter(_,1,W,W):-!.
gen_iter(N,I,L,W):- I1 is I-1,gen_iter(N,I1,[I1|L],W).


% Iter simplified
list1Ns(N,L) :-
   do(N,[],L).

do(1,A,[1|A]) :- !.
do(K,A,L) :-
  K1 is K-1,
  do(K1,[K|A],L).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% P22 (*):  Create a list containing all integers within a given range.

% range(I,K,L) :- I <= K, and L is the list containing all 
%    consecutive integers from I to K.
%    (integer,integer,list) (+,+,?)

range(I,I,[I]).
range(I,K,[I|L]) :- I < K, I1 is I + 1, range(I1,K,L).



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Stare rozwiązania:

% 1-N but append
listan(0,[]):- !.
listan(N,L):- N1 is N-1, listan(N1,L1),append(L1,[N],L).



% Recurrent down N-1
listanp(0,[]):- !.
listanp(N,[N|L1]):- N1 is N-1, listanp(N1,L1).
  
  


