wt(X,N):-var(X),!,p(N),write(X).
wt(f(X,Y,Z),N):- !,
   p(N),write('f('),nl, N1 is N+3,
   wt(X,N1),nl,
   wt(Y,N1),nl,
   wt(Z,N1),nl,
   p(N),write(' )'),nl.
wt(g(X,Y),N):- !,
   p(N),write('g('),nl, N1 is N+3,
   wt(X,N1),nl,
   wt(Y,N1),nl,
   p(N),write(' )'),nl.
wt(h(X),N):- !,
   p(N),write('h('),nl,N1 is N+3,
   wt(X,N1),nl,
   p(N),write(' )'),nl.
wt(X,N):- p(N),write(X).


p(0):- write(''),!.
p(N):- write(' '),N1 is N-1, p(N1).

%%% wypisywane list zagnieżdżonych typu [1,2,[3,4],5]
wl([H|T],D):- !, we(H,D), wl(T,D).
wl([],_).

we([H|T],D):- !,  D2 is D+3, wl([H|T],D2).
we(H,D):-  nl,p(D),write(H). 


wp([],_):- !.
wp(L,D):- wl(L,D).


%%% wf - wypisywanie termów typu f(a,b,g(c),d)).
wf(F):- D is 0,
	wfd(F,D).
wfd(F,D):- F =.. L, 
	   L=[H|T],
           p(D), write(H),nl,
           D3 is D+3, wa(T,D3).
wa([H|T],D):- atomic(H),!,p(D),write(H),nl,wa(T,D).
wa([H|T],D):- !, wfd(H,D),wa(T,D).
wa([],_).


